import { ethers } from "ethers";
import { useEffect, useState } from "react";
import { useNetwork } from "..";
import useSigner from "./useSigner";
export default function useBalance() {
    var _a = useState(undefined), intervalId = _a[0], setIntervalId = _a[1];
    var _b = useState(undefined), balance = _b[0], setBalance = _b[1];
    var chain = useNetwork();
    var signer = useSigner();
    var updateBalance = function (signer) {
        signer.getBalance().then(function (_balance) {
            var _a;
            // convert a currency unit from wei to ether
            var balanceInEth = parseFloat(ethers.utils.formatEther(_balance)).toFixed(2);
            setBalance("".concat(balanceInEth, " ").concat((_a = chain === null || chain === void 0 ? void 0 : chain.nativeCurrency) === null || _a === void 0 ? void 0 : _a.name));
        });
    };
    useEffect(function () {
        clearInterval(intervalId);
        if (signer) {
            updateBalance(signer);
            setIntervalId(setInterval(function () { return updateBalance(signer); }, 5000));
        }
        else {
            setBalance(undefined);
        }
    }, [signer, chain]);
    return balance;
}
